#include <time.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <GL/gl.h> 
#include <GL/oscontext.h> 
#include "ui.h"

char fnameMask[80];

#ifndef M_PI
#  define M_PI 3.14159265
#endif

#pragma pack(1)

typedef struct {
   char  idlength;
   char  colourmaptype;
   char  datatypecode;
   short int colourmaporigin;
   short int colourmaplength;
   char  colourmapdepth;
   short int x_origin;
   short int y_origin;
   short width;
   short height;
   char  bitsperpixel;
   char  imagedescriptor;
} tgaHeader;

#pragma pack()

int frames=0;
void *fbuff;

void tkSwapBuffers(void)
{
   tgaHeader tga;
   int i,r,g,b,v;
  char buff[16];
  FILE *out;
  frames++;
  sprintf(buff,fnameMask,frames);
  out=fopen(buff,"wb");
   memset(&tga,0,sizeof(tgaHeader));
   tga.datatypecode=2;
   tga.width=800;
   tga.height=600;
   tga.bitsperpixel=24;
   tga.imagedescriptor=0x20;
  fwrite(&tga,sizeof(tgaHeader),1,out);
  for (i=0; i<800*600; i++)
  {
    v=((unsigned short*)fbuff)[i];
    b = (v & 0x1F) << 3;
    g = (v & 0x07E0) >> 3;
    r = (v & 0xF800) >> 8;

    fputc(b,out); // OMG I can't belive I did this
    fputc(g,out); // OMG I can't belive I did this
    fputc(r,out); // OMG I can't belive I did this
    
/*    fputc(((char*)fbuff)[i*4+2],out); // OMG I can't belive I did this
    fputc(((char*)fbuff)[i*4+1],out); // OMG I can't belive I did this
    fputc(((char*)fbuff)[i*4+0],out); // OMG I can't belive I did this*/
  }
  //fwrite(fbuff,800*600,4,out);
  fclose(out);
  printf("%s saved.\n",buff);
}


int ui_loop(int argc, char **argv, const char *name)
{
   int i;
   sprintf(fnameMask,"%s%%i.tga",argv[0]);
   fbuff=(void*)gl_malloc(800*600*2);
   ostgl_context *cx = ostgl_create_context(800, 600, 16, &fbuff, 1);
   init();
   reshape(800, 600);
   for (i=0; i<3; i++)
      idle();
   ostgl_delete_context(cx);
   return 0;
}


